#!/usr/bin/php
<?php
/*
# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility 
# for any damage, accident or loss while using this script.

# Change username and password
*/

// Vervang  hieronder username en password 
$servername = "localhost";
$username = "<username>";
$password = "<password>";
$start_jaar=2019;
$versie='7.0';

// Hieronder niets meer aanpassen. 

$dbname = "p1";
$tabellen=array("maandverbruik_laag","maandverbruik_normaal","maandretour_laag","maandretour_normaal", "solar_power");
$tabel_kolommen=array("Verbruik_Laag","Verbruik_Normaal","Retour_Laag","Retour_Normaal","Verbruik_Gas","Verbruik_water");
$source_tabellen=array("maandverbruik_laag","maandverbruik_normaal","maandretour_laag","maandretour_normaal", "solar_power");
$jaar=date("Y");
$result_tabel=array();
$tabel="netsol" ;
$result_tabellen=array("maandverbruik_laag","maandverbruik_normaal","maandretour_laag","maandretour_normaal", "solar_power");
//print_r($prog);

$jaar_select="Jaar_2019";
$jaar_select_net="Net_Jaar_2019";
$jaar_select_sol="Sol_Jaar_2019";

$jaar_array=array();
$jaar_array[0]="Maand_id";
$jaar_array[1]=$jaar_select;
$i=2;
for ($k=$start_jaar + 1; $k <= $jaar;$k++){
  
  $jaar_select=$jaar_select . " , Jaar_$k";
	$jaar_select_net=$jaar_select_net . " , Net_Jaar_$k";
  $jaar_select_sol=$jaar_select_sol. " , Sol_Jaar_$k";
  $jaar_array[$i++]="Jaar_$k";
}
$aantal_jaren= $i;


// Debug parameter 0 = no debug 1 = debug
$ontluis=0;

if ($ontluis){
  echo "Jaar select is : $aantal_jaren --- $jaar_select \n";
  print_r($jaar_array);
  echo"\n";
}
/*


if ($ontluis){
  echo "argv[0] =". $argv[0] . " basename : ". basename($argv[0])  . "\n";
	echo "Executing  $programma \n"; 
}

*/



function write_logfile($tekst){
//  $logfile = "/tmp/maandverbruik_laag.log";
  $logfile = "/tmp/netsol.log";
  $mylog = fopen($logfile, "a") or die("Unable to open logfile!: ". $logfile);
  fwrite($mylog, "<" . date("Y-m-d H:i:s") . "> ". $tekst ."\n");
  fclose($mylog);
}

write_logfile("Start program create table : ". $tabel);

// Create connection
$conn = mysqli_connect($servername, $username, $password, $dbname);

// Check connection
if (!$conn) {
    write_logfile("Connection DB failed: " . mysqli_connect_error());
    die("Connection failed: " . mysqli_connect_error(). "\n");
}

if ($ontluis) {
  echo "Connected successfully\n";
  echo "\n\n";
}
write_logfile("Connected successfully to database p1");

for ($k = 0; $k < 5; $k++){
	//get data from from maandverbruik and put in array.
	$source_tabel=$source_tabellen[$k];
	$result_tabel[$k]=array($result_tabellen[$k]);
	$query = 'SELECT  Maand_id, ' . $jaar_select . '  FROM '. $source_tabel ;
	write_logfile("Get Data : ". $query);
	$i = 0;
	$result = mysqli_query($conn,$query);
	if (mysqli_num_rows($result) > 0) {
	  // output data of each row
	  if ($ontluis) {
	    echo "Aantal rijen > 0\n";
	  }
	  while($result_tabel[$k][] = mysqli_fetch_assoc($result)) ;
	}
	if ($ontluis){
		echo "\n $source_tabellen[$k] \n" ;   
//		print_r($result_tabel[$k]);
	}
}


echo "\n\n";
  
if ($ontluis){
//	print_r($result_tabel);
	print_r($result_tabel[0][0]);
   
	echo "Aantal jaren = " . count($result_tabel[0][1]) ."\n";
 	echo "\n Jaarselect = $jaar_select \n";
	echo "\n Jaarselect Net = $jaar_select_net \n";
	echo "\n Jaarselect Sol = $jaar_select_sol \n\n";
//  print_r($result_tabe['maandverbruik_laag'][1]);
}

// "0 = maandverbruik_laag","1 = maandverbruik_normaal","2 = maandretour_laag","3 = maandretour_normaal", "4 = solar_power"

$mnd_netsol=array();

if ($ontluis){
  for ($k = 0; $k < 5; $k++){
    echo "\n Tabel ". $result_tabel[$k][0] . "\n";
    for ($j = 1; $j < 13; $j++){
    $helpstring=$result_tabel[$k][0] ;    
     for ($i = 0; $i < $aantal_jaren; $i++){
       $helpstring=$helpstring . " " .  $result_tabel[$k][$j][$jaar_array[$i]] ."  ";  
     }
       echo $helpstring . "\n" ;   
    }     
  }
}

for ($j = 1; $j < 13; $j++){
   $mnd_netsol[$j][0][0] = $j;
   for ($i = 1; $i < $aantal_jaren; $i++){
//     echo  $result_tabel[0][$j][$jaar_array[$i]] + $result_tabel[1][$j][$jaar_array[$i]] . "\n";
     $mnd_netsol[$j][$i][1] = $result_tabel[0][$j][$jaar_array[$i]] + $result_tabel[1][$j][$jaar_array[$i]];  // net used
      $mnd_netsol[$j][$i][2] = $result_tabel[4][$j][$jaar_array[$i]] / 1000 - $result_tabel[2][$j][$jaar_array[$i]] -  $result_tabel[3][$j][$jaar_array[$i]]; //solar used directly
   }
}

//print_r($mnd_netsol);



// build create table string
// but first drop table if exists

$sql="DROP TABLE IF Exists ". $tabel . ";";
if (mysqli_query($conn,$sql)){
  if ($ontluis) {
    echo "Table ". $tabel ." deleted successfully\n";
  }
  write_logfile( "Table ". $tabel ." deleted successfully. ");
} else {
  if ($ontluis) {
    echo "Error deleting table: " . mysqli_error($conn). "\n";
  }
  write_logfile("Error deleting table: " . mysqli_error($conn));
}

$arr_jaar=array();
$data_string="";
$nr_of_jaar=$start_jaar;

for ($i=$start_jaar;$i<=$jaar;$i++){
	$data_string=$data_string .  " `Net_Jaar_" . $i. "` decimal(10,3) DEFAULT NULL, " .  " `Sol_Jaar_" . $i. "` decimal(10,3) DEFAULT NULL, ";
        $arr_jaar["$i"] = 0;
	$nr_of_jaar++;
}
if ($ontluis) {
	print_r($arr_jaar);

}


$sql = "CREATE TABLE " . $tabel."( ".
            "`maand_id` INT NOT NULL AUTO_INCREMENT, ".
            "`datum` DATETIME NOT NULL, ".
   	    $data_string  . 
            "PRIMARY KEY ( `maand_id` )); ";
write_logfile("Create Table : " . $sql);
if ($ontluis) {
  echo ("Create Table : " . $sql . "\n\n");
}



if (mysqli_query($conn,$sql)){
  if ($ontluis) {
    echo "Table ". $tabel ." created successfully\n";
  }
  write_logfile("Table ". $tabel ." created successfully");
} else {
  if ($ontluis) {
    echo "Error creating table: " . mysqli_error($conn) ."\n";
  }
  write_logfile("Error creating table: " . mysqli_error($conn) ); 
}



//Insert data in table.
$sql1="INSERT INTO ". $tabel . " VALUES (" ;
$sql2=");";
$rij_maand=01;

for ($j = 1; $j < 13; $j++){
   $rij_maand= $mnd_netsol[$j][0][0];
   $sql=$sql1 . $rij_maand . ',' . 'CONVERT("2021-' . $rij_maand .'-01 00:00:01", DATETIME)';
   
   for ($i = 1; $i < $aantal_jaren; $i++){
      $sql=$sql . ',' . $mnd_netsol[$j][$i][1]  . ', ' . $mnd_netsol[$j][$i][2]  ;    
   }
   $sql=$sql  . $sql2;
   if ($ontluis) {
      echo "\n" . $sql ."\n" ;
   }
  	if (mysqli_query($conn,$sql)){
	  if ($ontluis) {
	    echo "Row  ". $sql ." successfully inserted\n";
	  }
	  write_logfile("Row  ". $sql ." successfully inserted");
    } else {
	  if ($ontluis) {
	    echo "Error inserting row ". $sql . " ".  mysqli_error($conn) ."\n";
	  }
	  write_logfile("Error inserting row ". $sql . " " . mysqli_error($conn) ); 
	}
}

  
 

mysqli_close($conn);

write_logfile("Connection to database p1 closed.");
write_logfile("End  program create table : ". $tabel);
?>

