-- Script Gasperdag.sql
-- Auteur Peter Westerbeek
-- Script mag door iedereen gebruikt worden en aangepast worden
-- Maar laat aub deze commnetaar regels staan.
-- Dit script bepaalt het gasverbruik van  de afgelopen dag
-- en draait idere nacht om 00:10 uur.
INSERT INTO p1.p1_gasperdag (p1_timestamp,p1_gasverbruik) 
SELECT * 
FROM (
select timestamp(Date_Format(X.Dag, "%Y-%m-%d %H:%i:%s")) AS "datum",
                MAX(X.Gas) - MIN(X.gas) AS "Gas Verbruik"
        from
        (
        select date_format(DATE(CONVERT_TZ(`p1_timestamp`,'+00:00',@@global.time_zone)),"%Y-%m-%d" ) AS "Dag",
                p1_channel_1_meterreading AS "Gas"
        from p1.p1_log
        WHERE 1 = 1
            And p1_channel_1_meterreading >0
        --      and $__timeFilter(p1_timestamp)
            AND p1_timestamp > date_sub(CURDATE(), INTERVAL 2 DAY ) 
            order by p1_timestamp) X
            group by X.Dag) Y
WHERE Y.datum = DATE_FORMAT(date_sub(CURDATE(), INTERVAL 1 DAY ), "%Y-%m-%d 00:00:00")

