#!/bin/bash
# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility 
# for any damage, accident or loss while using this script.

# Change username and password
USERNAME="<username>"
PASSWORD="<password>"

unset LD_LIBRARY_PATH
#/opt/splunk/etc/apps/Energie/bin/solaredgemonth.php  > /tmp/solarmonth.tmp
/home/peter/bin/solaredgemonth.php  > /tmp/solarmonth.tmp
>/tmp/solarmonth.sql

CTIJD=`date '+%Y-%m-01 00:00'`
echo "SELECT  EXISTS ( select * from p1.p1_solaredgemonth where TIJD LIKE \"${CTIJD}%\" ) AS BESTAATROW ; " > /tmp/moncheck.sql
CHEK=`mysql -u ${USERNAME} -p${PASSWORD} -h localhost < /tmp/moncheck.sql | tail -1 `
#echo "CHEK = ${CHEK}"
if [ ${CHEK} -eq 1 ]
then
	INSUP=UPDATE
else
	INSUP=INSERT
fi
DAG=`date '+%d'`
HTIJD=`date '+%Y-%m-01 00:00:'${DAG}`
#echo "INSUP = ${INSUP} Dag = ${DAG} HTIJD = ${HTIJD}"

tail -2 /tmp/solarmonth.tmp | while read REGEL
#cat /tmp/solarmonth.tmp | while read REGEL
do
        CHRLEN=${#REGEL}
        if [ ${CHRLEN} -gt 5 ]
        then
          TIJD=`echo ${REGEL} |cut -f1-2 -d' '`
          POWER=`echo ${REGEL} | cut -f3- -d' '`
	  if [ ${CHEK} -eq 1 ]
	  then
		 echo "UPDATE p1.p1_solaredgemonth SET TIJD = \"${HTIJD}\" , ${POWER} WHERE Tijd LIKE \"${CTIJD}%\" ;"  >> /tmp/solarmonth.sql
	  else
          	echo "INSERT INTO p1.p1_solaredgemonth SET Tijd = \"${HTIJD}\", ${POWER} ;"  >> /tmp/solarmonth.sql
	  fi
#          echo "INSERT INTO p1.p1_solaredgemonth SET Tijd = \"${TIJD}\", ${POWER} ;"
        fi
done
mysql -u ${USERNAME} -p${PASSWORD} -h localhost < /tmp/solarmonth.sql
