#!/usr/bin/php
/*
# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility 
# for any damage, accident or loss while using this script.

# Change username and password
*/

<?php
$servername_s = "localhost";
$username_s = "<username>";
$password_s = "<password>";
$dbname_s = "p1";
$tabel_s="p1_water";
$tabel_kolom_s="Datum";


$tabel_d="p1_wateruur";
$tabel_kolom_d="Datum";


$jaar=date("Y");
// Debug parameter 0 = no debug 1 = debug
$ontluis=1;



function write_logfile($tekst){
//  $logfile = "/tmp/vul_aan.log";
  $logfile = "/tmp/wateruur.log";
  $mylog = fopen($logfile, "a") or die("Unable to open logfile!: ". $logfile);
  fwrite($mylog, "<" . date("Y-m-d H:i:s") . "> ". $tekst ."\n");
  fclose($mylog);
}

write_logfile("Start program wateruur.php. table : ". $tabel_s);

// Create connection source
$conn_s = mysqli_connect($servername_s, $username_s, $password_s, $dbname_s);

// Check connection source 
if (!$conn_s) {
    write_logfile("Connection DB failed at host " . $servername_s . ". Error: " . mysqli_connect_error());
    die("Connection failed at host " . $servername_s . ". Error: " . mysqli_connect_error(). "\n");
}

if ($ontluis) {
  echo "Connected successfully at host " . $servername_s . "\n";
  echo "\n\n";
}
write_logfile("Connected successfully to database p1 at host " . $servername_s);




//get data from from maandverbruik and put in array.
$query = 'SELECT  ' . $tabel_kolom_d . ' FROM ' . $tabel_d .' ORDER BY '. $tabel_kolom_d . ' DESC LIMIT 1';
if ($ontluis) {
  echo "Query  uur_water = " . $query . "\n";
}
write_logfile("Get Data : ". $query);
$i = 0;
$result = mysqli_query($conn_s,$query);
if (mysqli_num_rows($result) > 0) {
  // output data of each row
  while($row[] = mysqli_fetch_assoc($result)) ;
  $start_tijd = $row[0][$tabel_kolom_d];
  if ($ontluis) {
    echo "Start tijd uur_water = " . $start_tijd  . "\n";
  }
}
else {

//$query = 'SELECT  * FROM ' . $tabel_s .' WHERE ' . $tabel_kolom_s . ' > "'.  $start_tijd . '"  LIMIT 10';
  $query = 'SELECT  * FROM ' . $tabel_s . ' ORDER BY '. $tabel_kolom_s . ' ASC LIMIT 1';
  if ($ontluis) {
    echo "Query  water = " . $query . "\n";
  }

 
  $result = mysqli_query($conn_s,$query);
  if (mysqli_num_rows($result) > 0) {
    // output data of each row
    while($rij[] = mysqli_fetch_assoc($result)) ;
  }
  $start_tijd = $rij[0][$tabel_kolom_s];
    
  if ($ontluis) {
    echo "Start tijd water = " . $start_tijd  . "\n";
  }  
}
$query = 'SELECT DATE_FORMAT(Datum,"%Y-%m-%d %H:00:00") as Datum , Total_liter_m3 as Stand FROM ' . $tabel_s . " WHERE  1 = 1  AND Datum > '". $start_tijd. "'" . 
         'AND DATE_FORMAT(Datum,"%i:00")' . " LIKE '02%'";
if ($ontluis) {
  echo "Query  select water row = " . $query . "\n";
}
$result = mysqli_query($conn_s,$query);
if (mysqli_num_rows($result) > 0) {
  // output data of each row
  while($rij2[] = mysqli_fetch_assoc($result)) ;
}

$len_rij2=count($rij2);
if ($ontluis) {
  echo "Aantal rijen  = " . $len_rij2 . "\n";
}
$rij1=$rij2[0];


$sql="SET SQL_MODE='ALLOW_INVALID_DATES'";
if (mysqli_query($conn_s,$sql)){
	  if ($ontluis) {
	    echo "SQL Mode successfully set\n";
	  }
	  write_logfile("SQL Mode successfully set");
	} else {
	  if ($ontluis) {
	    echo "Error SQL Mode set ". $sql . " ".  mysqli_error($conn_s) ."\n";
	  }
	  write_logfile("Error SQL Mode set ". $sql . " " . mysqli_error($conn_s) ); 
}

echo "Start inserting rows \n";
//Insert data in table.
$sql1="INSERT INTO ". $tabel_d . " VALUES (" ;
$sql2=");";


for ($i=1; $i<$len_rij2; $i++){
// for ($i=1; $i<20; $i++){
       
    $subrij2=$rij2[$i];
    if (isset($rij2[$i])){
      $verbruik=$subrij2['Stand'] - $rij1['Stand'];
      $mysqltime=strtotime( $subrij2['Datum']);
      if ($ontluis) {  
        $regel= "I = $i " . "Rij2 : ".  $subrij2['Datum'] . " Rij1 ".  $rij1['Datum'] . " Stand1 : " . $rij1['Stand'] . " Stand2 : " . $subrij2['Stand'] . " Verbruik : " . $verbruik . 
        " Mysqltime= ". $mysqltime .  "\n";
        echo $regel;
      }
 

      $regel = "0";
      
      $regel= $regel . ',"'  . $subrij2['Datum'] .'" ,'. $rij1['Stand'] ."," . $subrij2['Stand'] . "," . $verbruik;
      $sql=$sql1 . $regel . $sql2; 
     	if ($ontluis ) {
//     	  echo "-----------------------------------------------\n";
    	  echo $sql . "\n";
    	  write_logfile($sql);
      }
    
    	if (mysqli_query($conn_s,$sql)){
    	  if ($ontluis) {
    	    echo "Row  ". $sql ." successfully inserted\n"; 	  
      	  write_logfile("Row  ". $sql ." successfully inserted");
        }
    	} else {
    	  if ($ontluis) {
    	    echo "Error inserting row ". $sql . " ".  mysqli_error($conn_s) ."\n";
    	  }
    	  write_logfile("Error inserting row ". $sql . " " . mysqli_error($conn_s) ); 
    	}

      $rij1=$rij2[$i];
    }
}


$aantal=$len_rij2 - 1;
echo "\n\nRows inserted : " . $aantal . "\n";
write_logfile("Rows inserted : " . $aantal);

mysqli_close($conn_s);

write_logfile("Connection to database p1 closed.");
?>

