-- Script Waterverbruik.sql
-- Auteur Peter Westerbeek
-- Script mag door iedereen gebruikt worden en aangepast worden
-- Maar laat aub deze commnetaar regels staan.
-- Dit script bepaalt het elctriciteits gebruik en retour van de afgelopen dag
-- en draait idere nacht om 00:10 uur.
INSERT INTO p1.p1_waterverbruik (p1_timestamp,p1_waterverbruik) 
SELECT * 
FROM (
select timestamp(Date_Format(X.Dag, "%Y-%m-%d %H:%i:%s")) AS "datum",
        max(X.Waterverbruik)- min(X.Waterverbruik) as "Water Verbruik"
from
(
select date_format(Datum,"%Y-%m-%d" ) AS "Dag",
        Total_liter_m3 as "Waterverbruik"
from p1.p1_water
WHERE 1 = 1
--      and $__timeFilter(Datum)
   AND Datum > date_sub(CURDATE(), INTERVAL 2 DAY ) 
        order by Datum) X
        group by X.Dag) Y
      WHERE Y.datum = DATE_FORMAT(date_sub(CURDATE(), INTERVAL 1 DAY ), "%Y-%m-%d 00:00:00")

