-- Script Elecverbuik.sql
-- Auteur Peter Westerbeek
-- Script mag door iedereen gebruikt worden en aangepast worden
-- Maar laat aub deze commnetaar regels staan.
-- Dit script bepaalt het elctriciteits gebruik en retour van de afgelopen dag
-- en draait idere nacht om 00:10 uur.
INSERT INTO p1.p1_elecverbruik (p1_timestamp,p1_laagverbruik, p1_normaalverbruik,p1_laagretour,p1_normaalretour) 
SELECT * 
FROM (
select timestamp(Date_Format(X.Dag, "%Y-%m-%d %H:%i:%s")) AS "datum",
        max(X.Laagin)- min(X.Laagin) as "Laag Verbruik",
        max(X.Normaalin)- min(X.Normaalin) as "Normaal Verbruik",
        max(X.Laagout)- min(X.Laagout) as "Laag Retour",
        max(X.Normaalout)- min(X.Normaalout) as "Normaal Retour"
from
(
select date_format(DATE(CONVERT_TZ(`p1_timestamp`,'+00:00',@@global.time_zone)),"%Y-%m-%d" ) AS "Dag",
        p1_meterreading_in_1 as "Laagin",
        p1_meterreading_in_2 as "Normaalin",
        p1_meterreading_out_1 as "Laagout",
        p1_meterreading_out_2 as "Normaalout"
from p1.p1_log
WHERE 1 = 1
--      and $__timeFilter(p1_timestamp)
   AND p1_timestamp > date_sub(CURDATE(), INTERVAL 2 DAY ) 
        order by p1_timestamp) X
        group by X.Dag) Y
      WHERE Y.datum = DATE_FORMAT(date_sub(CURDATE(), INTERVAL 1 DAY ), "%Y-%m-%d 00:00:00")

