#!/bin/bash
# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility 
# for any damage, accident or loss while using this script.

# Change username and password
USERNAME=<username>
PASSWORD=<password>

cd //home/peter/bin
/usr/bin/mysql -B -h localhost -D p1 -u ${USERNAME} -p${PASSWORD} -N  -e "source maandverbruik.sql" > /tmp/maandverbr.tmp
>/tmp/maandverbr.sql
CTIJD=`date '+%Y-%m-01 00:00'`
echo "SELECT  EXISTS ( select * from p1.p1_maandverbruik where TIJD LIKE \"${CTIJD}%\" ) AS BESTAATROW ; " > /tmp/maandverbrcheck.sql
CHEK=`mysql -h localhost -D p1 -u ${USERNAME} -p${PASSWORD} < /tmp/maandverbrcheck.sql | tail -1 `
echo "CHEK = ${CHEK}"
if [ ${CHEK} -eq 1 ]
then
        INSUP=UPDATE
else
        INSUP=INSERT
fi
DAG=`date '+%d'`
HTIJD=`date '+%Y-%m-01 00:00:'${DAG}`
#echo "INSUP = ${INSUP} Dag = ${DAG} HTIJD = ${HTIJD}"


#tail -1 /tmp/maandverbr.tmp | tac | tail -3 | while read REGEL
tail -1 /tmp/maandverbr.tmp |  while read REGEL
#cat  /tmp/maandverbr.tmp |  while read REGEL
do
        CHRLEN=${#REGEL}
        if [ ${CHRLEN} -gt 5 ]
        then
          TIJD=`echo ${REGEL} |cut -f1-2 -d' ' | sed "s/00$/${DAG}/"`
          MIN_LAAG=`echo ${REGEL} | cut -f3 -d' '`
          MAX_LAAG=`echo ${REGEL} | cut -f4 -d' '`
          VERBRUIK_LAAG=`echo ${REGEL} | cut -f5 -d' '`
          MIN_NORMAAL=`echo ${REGEL} | cut -f6 -d' '`
          MAX_NORMAAL=`echo ${REGEL} | cut -f7 -d' '`
          VERBRUIK_NORMAAL=`echo ${REGEL} | cut -f8 -d' '`
          MIN_ELECLAAGOUT=`echo ${REGEL} | cut -f9 -d' '`
          MAX_ELECLAAGOUT=`echo ${REGEL} | cut -f10 -d' '`
          RETOUR_LAAG=`echo ${REGEL} | cut -f11 -d' '`
          MIN_ELECNORMAALOUT=`echo ${REGEL} | cut -f12 -d' '`
          MAX_ELECNORMAALOUT=`echo ${REGEL} | cut -f13 -d' '`
          RETOUR_NORMAAL=`echo ${REGEL} | cut -f14 -d' '`
          MIN_GAS=`echo ${REGEL} | cut -f15 -d' '`
          MAX_GAS=`echo ${REGEL} | cut -f16 -d' '`
          VERBRUIK_GAS=`echo ${REGEL} | cut -f17 -d' '`
          if [ ${CHEK} -eq 1 ]
          then
                 echo "UPDATE p1.p1_maandverbruik SET TIJD = \"${TIJD}\" , MIN_LAAG = ${MIN_LAAG}, MAX_LAAG = ${MAX_LAAG}, VERBRUIK_LAAG = ${VERBRUIK_LAAG}, MIN_NORMAAL =  ${MIN_NORMAAL},  MAX_NORMAAL = ${MAX_NORMAAL}, VERBRUIK_NORMAAL = ${VERBRUIK_NORMAAL}, MIN_ELECLAAGOUT =  ${MIN_ELECLAAGOUT}, MAX_ELECLAAGOUT = ${MAX_ELECLAAGOUT},RETOUR_LAAG = ${RETOUR_LAAG}, MIN_ELECNORMAALOUT = ${MIN_ELECNORMAALOUT}, MAX_ELECNORMAALOUT = ${MAX_ELECNORMAALOUT}, RETOUR_NORMAAL = ${RETOUR_NORMAAL},  MIN_GAS = ${MIN_GAS}, MAX_GAS = ${MAX_GAS}, VERBRUIK_GAS = ${VERBRUIK_GAS}
 WHERE Tijd LIKE \"${CTIJD}%\" ;"  >> /tmp/maandverbr.sql
          else
                echo "INSERT INTO p1.p1_maandverbruik SET Tijd = \"${TIJD}\", MIN_LAAG = ${MIN_LAAG}, MAX_LAAG = ${MAX_LAAG}, VERBRUIK_LAAG = ${VERBRUIK_LAAG}, MIN_NORMAAL =  ${MIN_NORMAAL},  MAX_NORMAAL = ${MAX_NORMAAL}, VERBRUIK_NORMAAL = ${VERBRUIK_NORMAAL}, MIN_ELECLAAGOUT =  ${MIN_ELECLAAGOUT}, MAX_ELECLAAGOUT = ${MAX_ELECLAAGOUT},RETOUR_LAAG = ${RETOUR_LAAG}, MIN_ELECNORMAALOUT = ${MIN_ELECNORMAALOUT}, MAX_ELECNORMAALOUT = ${MAX_ELECNORMAALOUT}, RETOUR_NORMAAL = ${RETOUR_NORMAAL},  MIN_GAS = ${MIN_GAS}, MAX_GAS = ${MAX_GAS}, VERBRUIK_GAS = ${VERBRUIK_GAS}
 ;"  >> /tmp/maandverbr.sql
          fi
        fi
done
mysql -h localhost -D p1 -u ${USERNAME} -p${PASSWORD} < /tmp/maandverbr.sql
cat /tmp/maandverbr.sql


