Set @Vandaag := Cast(Date_format(sysdate(),'%Y-%m-01 00:00:00') as datetime); 
-- Set @Vandaag := Cast('2020-01-00 00:00:00' as datetime);
-- Set @Vandaag := Cast('2020-03-01 00:00:00' as datetime);
SELECT concat(Tijd,'-01 00:00:00')  as 'Datum', Min_Laag, Max_laag, Max_laag - Min_Laag AS 'Verbruik_Laag',
		 Min_Normaal, Max_Normaal, Max_Normaal - Min_Normaal AS 'Verbruik_Normaal',
		 Min_ElecLaagOut, Max_ElecLaagOut, Max_ElecLaagOut - Min_ElecLaagOut AS 'Retour_Laag',
		 Min_ElecNormaalOut, Max_ElecNormaalOut, Max_ElecNormaalOut - Min_ElecNormaalOut AS 'Retour_Normaal',
		 Min_Gas, Max_Gas, Max_Gas - Min_Gas AS 'Verbruik_Gas'
		FROM (
		SELECT Tijd, MIN(Laag) AS 'Min_Laag', MAX(Laag) AS 'Max_Laag', 
					 MIN(Normaal) AS 'Min_Normaal', MAX(Normaal) AS 'Max_Normaal',
					 MIN(ElecLaagOut) AS 'Min_ElecLaagOut', MAX(ElecLaagOut) AS 'Max_ElecLaagOut',
					 MIN(ElecNormaalOut) AS 'Min_ElecNormaalOut', MAX(ElecNormaalOut) AS 'Max_ElecNormaalOut',
					 MIN(Gas) AS 'Min_Gas', MAX(Gas) AS 'Max_Gas'
		FROM (
			SELECT DATE_FORMAT(DATE(CONVERT_TZ(`p1_timestamp`,'+00:00',@@global.time_zone)), '%Y-%m') AS 'Tijd',
					 p1_meterreading_in_1 AS 'Laag',
					 p1_meterreading_in_2 AS 'Normaal', 
					 p1_meterreading_out_1 AS 'ElecLaagOut', 
					 p1_meterreading_out_2 AS 'ElecNormaalOut',
					 p1_channel_1_meterreading as 'Gas'
			FROM p1_log
			WHERE 	
				p1_timestamp >  @Vandaag
                    and p1_channel_1_meterreading >0 

                     limit 200000
				) X
		-- Where X.Tijd  > '2018-00' 
		GROUP BY X.Tijd
        ) Y;


