#!/usr/bin/php
<?php
/*

# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility 
# for any damage, accident or loss while using this script.

# Change username and password
*/

// Vervang  hieronder username en password 
$username = "<username>";
$password = "<password>";
// Debug parameter 0 = no debug 1 = debug
$ontluis=0;
//
// Startjaar is jaar vanaf welk jaar de tabellen opgebouwd moeten worden. 
//
$start_jaar=2020;

// Hieronder niets meer aanpassen. 

$servername = "localhost";
$dbname = "p1";
$jaar=date("Y");
//$prog=array("mnd_kosten.php", "mnd_grafana_verbruik_normaal.php","mnd_grafana_retour_laag.php", "mnd_grafana_retour_normaal.php", "mnd_grafana_verbruik_gas.php");
//$tabellen=array("maandverbruik_laag","maandverbruik_normaal","maandretour_laag","maandretour_normaal", "maandverbruik_gas");
//$tabel_kolommen=array("Verbruik_Laag","Verbruik_Normaal","Retour_Laag","Retour_Normaal","Verbruik_Gas");
$prog=array("mnd_kosten.php");
$tabellen=array("maand_kosten");
$input_tabellen=array("p1_kosten");
$tabel_kolommen=array("kosten_verbruik_laag ,kosten_verbruik_normaal, kosten_verbruik_gas, opbrengst_retour_laag, opbrengst_retour_normaal, vaste_kosten, corr_kosten_verbruik_gas");
$waardes=array();
$waardes=explode(",",$tabel_kolommen[0]);
$len_waardes=count($waardes);
//print_r($prog);
//echo "argv[0] =". $argv[0] . " basename : ". basename($argv[0]) . "prog[0] : " . $prog[0] . "\n";
for ($k = 0; $k < 1; $k++){
  if ($prog[$k] == basename($argv[0]) ) {
    $tabel=$tabellen[$k];
    $tabel_kolom=$tabel_kolommen[$k];
    $input_tabel=$input_tabellen[$k]; 
    $programma=$prog[$k];
    break; 
  }
}
if ($ontluis){
  print_r($waardes);
	echo "Executing  $programma \n"; 
}



function write_logfile($tekst){
//  $logfile = "/tmp/maandverbruik_laag.log";
  $logfile = "/tmp/". $GLOBALS['tabel']. ".log";
  $mylog = fopen($logfile, "a") or die("Unable to open logfile!: ". $logfile);
  fwrite($mylog, "<" . date("Y-m-d H:i:s") . "> ". $tekst ."\n");
  fclose($mylog);
}

write_logfile("Start program create table : ". $tabel);

// Create connection
$conn = mysqli_connect($servername, $username, $password, $dbname);

// Check connection
if (!$conn) {
    write_logfile("Connection DB failed: " . mysqli_connect_error());
    die("Connection failed: " . mysqli_connect_error(). "\n");
}

if ($ontluis) {
  echo "Connected successfully\n";
  echo "\n\n";
}
write_logfile("Connected successfully to database p1");


//get data from from $input_tabel and put in array.
$query = 'SELECT  DATE_FORMAT(Tijd,"%Y") AS Jaar, DATE_FORMAT(Tijd,"%m") AS Maand, '. $tabel_kolom . ' FROM '. $input_tabel . ' ORDER BY MAAND, JAAR';
write_logfile("Get Data : ". $query);
$i = 0;
$result = mysqli_query($conn,$query);
if (mysqli_num_rows($result) > 0) {
  // output data of each row
  while($row[] = mysqli_fetch_assoc($result)) ;
}


$maandverbruik=$row;
$len_maandverbruik=count($maandverbruik);
if ($ontluis) {
	for ($i=0; $i<$len_maandverbruik; $i++){ 
	//  print_r($maandverbruik[$i]);
	  $rij=$maandverbruik[$i];
	  if (isset($maandverbruik[$i])){ 
	    $regel= "I = $i Jaar : ".  $rij['Jaar'] . " Maand : ".  $rij['Maand'] . " Waardes : " . $rij['kosten_verbruik_laag'] . "  ". $rij['kosten_verbruik_normaal']. 
      "  ".  $rij['kosten_verbruik_gas'] . "  ". $rij['opbrengst_retour_laag'] . "  ". $rij['opbrengst_retour_normaal'] . "  ". $rij['vaste_kosten'] . "  ".  $rij['corr_kosten_verbruik_gas'] ." ".  "\n";
	    echo $regel;
	  } 
	}
}



echo "\n\n";

// build create table string
// but first drop table if exists

$sql="DROP TABLE IF Exists ". $tabel . ";";
if (mysqli_query($conn,$sql)){
  if ($ontluis) {
    echo "Table ". $tabel ." deleted successfully\n";
  }
  write_logfile( "Table ". $tabel ." deleted successfully. ");
} else {
  if ($ontluis) {
    echo "Error deleting table: " . mysqli_error($conn). "\n";
  }
  write_logfile("Error deleting table: " . mysqli_error($conn));
}



$arr_jaar=array();
$data_string="";
$nr_of_jaar=$start_jaar;

for ($i=$start_jaar;$i<=$jaar;$i++){
	$data_string=$data_string .  " `Kosten_Verbruik_Laag_" . $i. "` decimal(10,2) DEFAULT NULL, ";
 	$data_string=$data_string .  " `Kosten_Verbruik_Normaal_" . $i. "` decimal(10,2) DEFAULT NULL, ";
 	$data_string=$data_string .  " `Kosten_Verbruik_Gas_" . $i. "` decimal(10,2) DEFAULT NULL, ";
 	$data_string=$data_string .  " `Opbrengst_Retour_Laag_" . $i. "` decimal(10,2) DEFAULT NULL, ";
 	$data_string=$data_string .  " `Opbrengst_Retour_Normaal_" . $i. "` decimal(10,2) DEFAULT NULL, ";
 	$data_string=$data_string .  " `Vaste_Kosten_" . $i. "` decimal(10,2) DEFAULT NULL, ";
 	$data_string=$data_string .  " `Corr_Kosten_Verbruik_Gas_" . $i. "` decimal(10,2) DEFAULT NULL, ";
        $arr_jaar["$i"] = 0;
	$nr_of_jaar++;
}
if ($ontluis) {
//	print_r($arr_jaar);
// print_r($maandverbruik);
  echo $data_string ."\n\n";
}



$sql = "CREATE TABLE " . $tabel."( ".
            "`maand_id` INT NOT NULL AUTO_INCREMENT, ".
            "`datum` DATETIME NOT NULL, ".
   	    $data_string  . 
            "PRIMARY KEY ( `maand_id` )); ";
write_logfile("Create Table : " . $sql);
if ($ontluis) {
  echo ("Create Table : " . $sql . "\n\n");
}

if (mysqli_query($conn,$sql)){
  if ($ontluis) {
    echo "Table ". $tabel ." created successfully\n";
  }
  write_logfile("Table ". $tabel ." created successfully");
} else {
  if ($ontluis) {
    echo "Error creating table: " . mysqli_error($conn) ."\n";
  }
  write_logfile("Error creating table: " . mysqli_error($conn) ); 
}

//Insert data in table.
$sql1="INSERT INTO ". $tabel . " VALUES (" ;
$sql2=");";
$rij_maand=01;
for ($i=0; $i<$len_maandverbruik; $i++){ 
//   print_r($maandverbruik[$i]);
  $rij=$maandverbruik[$i];
  if ( $rij_maand != $rij['Maand'] ) {
    if ($ontluis) print_r($arr_jaar);

  	  $sql=$sql1 . $rij_maand . ',' . 'CONVERT("2021-' . $rij_maand .'-01 00:00:01", DATETIME)';
  	  for ($j=$start_jaar;$j < $nr_of_jaar ; $j++) {
       if ($arr_jaar[$j] == '0' ){
         $arr_jaar[$j]='0,0,0,0,0,0,0';
       }
 
         $sql = $sql . ",".  $arr_jaar[$j] ;
 //        echo " J= ". $j . "Arr_Jaar = " . $arr_jaar[$j] ."\n";
  	    $arr_jaar[$j] = 0;
  	  } 
  	  $sql = $sql . $sql2;
  
  	  if ($ontluis ) {
  //     	  echo "-----------------------------------------------\n";
  	      echo $sql . "\n";
  	      write_logfile($sql);
      }
  	  $rij_maand=$rij['Maand'] ;
  
  	  if (mysqli_query($conn,$sql)){
  	    if ($ontluis) {
  	      echo "Row  ". $sql ." successfully inserted\n";
  	    }
  	  write_logfile("Row  ". $sql ." successfully inserted");
  	  } else {
  	    if ($ontluis) {
  	      echo "Error inserting row ". $sql . " ".  mysqli_error($conn) ."\n";
  	    }
  	    write_logfile("Error inserting row ". $sql . " " . mysqli_error($conn) ); 
  	  }

    }
    $arr_jaar[$rij['Jaar']]=$rij['kosten_verbruik_laag'] . "," . $rij['kosten_verbruik_normaal']. 
      ", ".  $rij['kosten_verbruik_gas'] . " ,". $rij['opbrengst_retour_laag'] . ", ". $rij['opbrengst_retour_normaal'] . ", ". $rij['vaste_kosten'] . ", " . $rij['corr_kosten_verbruik_gas'] . " ";
    
 //    $arr_jaar[$rij['Jaar']]=$rij["$waardes[0]"];
 //   for ($l=1; $l < $len_waardes; $l++) {
 //    $arr_jaar[$rij['Jaar']] = $arr_jaar[$rij['Jaar']]  . "," . $rij["$waardes[$l]"] ;
 //    }
    if ($ontluis) {
       echo "Arr_jaar = ".  $rij['Jaar'] ."\n";
       print_r( $arr_jaar[$rij['Jaar']]) ;
       echo "\n";
    }
}



mysqli_close($conn);

write_logfile("Connection to database p1 closed.");
write_logfile("End  program create table : ". $tabel);
?>

